#include <stdio.h>
#include <string.h>
#include <stdlib.h>

static char *substitute_range(char *cat) {
	char *categories=strdup(cat);
	char *ptr;
	char *tok=strtok_r(categories,",",&ptr);
	char *r=NULL;
	char *sub=strdup("");
	int error=0;
	int len=0;
	while (tok) {
		if ((r=strchr(tok,'.')) !=0) {
			int begin=atoi(&tok[1]);
			++r;
			int end=atoi(&r[1]);
			char *tmp=sub;
			for (;begin<end+1;begin++) {
				char *tmp=sub;
				if (asprintf(&sub,"%sc%d,", sub, begin) < 0) {
					error=1;
					break;
				}
				free(tmp);
			}
		}
		tok=strtok_r(NULL,",",&ptr);
	}	
	free(categories);
	if (error) {
		free(sub);
	} 
	else {
		int len=strlen(sub);
		if (len) {
			if (sub[len-1] == ',') sub[len-1]=0;
			return sub;
		}
	}
	return strdup(cat);
}

int main(int argc, char **argv) {
	char *ptr=substitute_range(argv[1]);
	printf("%s\n",ptr);
	free(ptr);
}
